Subject: Re: [RFC] batched tc to improve change throughput

From: Thomas Graf <[email-masked]>
Date: Thu, 20 Jan 2005 18:19:40 +0100

* Stephen Hemminger <[email-masked]> 2005-01-20 09:06
> On Thu, 20 Jan 2005 16:35:59 +0100
> Thomas Graf <[email-masked]> wrote:
> 
> > * jamal <[email-masked]> 2005-01-20 09:42
> > > I like it. Assuming we can have arbitrary hierachies; you just show one
> > > level - but that may be just the example at hand. Given that should be
> > > able to meet the layout requirements that Lennert alluded to earlier.
> > 
> > It doesn't include any context code, the BNF:
> > 
> > PARSER    := TOPNODE*
> > TOPNODE   := NODELIST DESC LONG_DESC
> > NODELIST  := NODE*
> > NODE      := DESC [ NODELIST ] [ ARGUMENT ] [ ATTRS ] [ END_POINT ]
> > END_POINT := possible end of command
> > ATTRS     := ATTR*
> > ATTR      := KEY [ VALUE ]
> > ARGUMENT  := VALUE [ DESC ]
> > 
> > Not sure if this helps, I attached a complete module below.
> > 
> 
> A couple additional suggestions.  It would be great to get a useful API
> to for 'tc' that is one step above actual low level netlink stuff.

Planned. Trying to reuse an existing grammar but didn't found that
suits well enough yet.

> And it would be great to reuse some existing scripting language grammar
> and parsing library infrastructure.

Tried very hard to do so. I'd really like to build upon readline and
its completion method but most parser generators are not made to get along
with readline + completion. A c++ hack exist but doesn't really work
with completion. That's why I wrote my own grammar definition thing.